package com.steerinfo.ems.foldthevalues.controller;

import com.steerinfo.ems.foldthevalues.mapper.FoldTheValuesMapper;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.ems.foldthevalues.model.FoldTheValues;
import com.steerinfo.ems.foldthevalues.service.IFoldTheValuesService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.script.ScriptException;
import java.text.ParseException;
import java.util.*;
import java.math.BigDecimal;

/**
 * FoldTheValues RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-14 02:33
 * 类描述
 * 修订历史：
 * 日期：2021-10-14
 * 作者：generator
 * 参考：
 * 描述：FoldTheValues RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/foldthevaluess")
public class FoldTheValuesController extends BaseRESTfulController {

    @Autowired
    IFoldTheValuesService foldTheValuesService;
    @Autowired
    FoldTheValuesMapper foldTheValuesMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("foldthevalues:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<FoldTheValues> list = foldTheValuesService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("foldthevalues:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<FoldTheValues> list = foldTheValuesService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据FoldTheValues对象创建")
    @ApiImplicitParam(name = "foldTheValues", value = "详细实体foldTheValues", required = true, dataType = "FoldTheValues")
    //@RequiresPermissions("foldthevalues:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute FoldTheValues model){
        FoldTheValues foldTheValues = foldTheValuesService.add(model);
        return success(foldTheValues);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("foldthevalues:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        FoldTheValues foldTheValues = foldTheValuesService.getById(id);
        return success(foldTheValues);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的foldTheValues信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "foldTheValues", value = "详细实体foldTheValues", required = true, dataType = "FoldTheValues")
    })
    //@RequiresPermissions("foldthevalues:update")
    @PutMapping(produces  = "application/json;charset=UTF-8")
    public RESTfulResult update( @RequestBody FoldTheValues[] models){
        for (FoldTheValues model : models) {
            foldTheValuesMapper.updateByPrimaryKey(model);
        }
        return success();
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("foldthevalues:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  foldTheValuesService.delete(ids);
    	}
      return success();
    }

    @GetMapping("/aaa")
    public RESTfulResult getdate() throws ScriptException, ParseException {
//        foldTheValuesService.getDate();
         //foldTheValuesService.getMonthData();
           //foldTheValuesService.getDataForwl();
        //foldTheValuesService.insertNewDate();
        return  success();
    }
    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("foldthevalues:view")
    @GetMapping(value = "/getDateForPage")
    public RESTfulResult getDateForPage (@RequestParam HashMap<String, Object> parmas,Integer pageNum, Integer pageSize) {
        if(parmas.get("energyid") != null && !parmas.get("energyid").toString().isEmpty()){
            String energyid = parmas.get("energyid").toString();
            if(!energyid.startsWith("'")){
                energyid = "'" + energyid.replaceAll(",", "','").replaceAll("，", "','") + "'";
            }
            parmas.put("energyid", energyid);
        }
        PageList<Map<String, Object>> forPage = foldTheValuesService.getDateForPage(parmas, pageNum, pageSize);
        return success(forPage);
    }

}
